<?php

/**
 * FiloBlu\AjaxLayeredNavigation\Block\System\Config\Form\Field\Events
 *
 * @category    FiloBlu
 * @package     FiloBlu_AjaxLayeredNavigation
 * @author      Vincenzo Assenza
 *
 */


namespace FiloBlu\AjaxLayeredNavigation\Block\System\Config\Form\Field;

use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;
use Magento\Framework\DataObject;

/**
 *
 */
class Events extends AbstractFieldArray
{

    protected $_arrayRowsCache;

    protected $_addAfter = true;

    /**
     * @return array|null
     */
    public function getArrayRows()
    {
        if (null !== $this->_arrayRowsCache) {
            return $this->_arrayRowsCache;
        }
        $result = [];
        /** @var \Magento\Framework\Data\Form\Element\AbstractElement */
        $element = $this->getElement();

        if ($element->getValue() && !is_array($element->getValue())) {
            $element->setValue(unserialize($element->getValue()));
        }

        if ($element->getValue() && is_array($element->getValue())) {
            foreach ($element->getValue() as $rowId => $row) {
                $rowColumnValues = [];
                foreach ($row as $key => $value) {
                    $row[$key] = $value;
                    $rowColumnValues[$this->_getCellInputElementId($rowId, $key)] = $row[$key];
                }
                $row['_id'] = $rowId;
                $row['column_values'] = $rowColumnValues;
                $result[$rowId] = new DataObject($row);
                $this->_prepareArrayRow($result[$rowId]);
            }
        }
        $this->_arrayRowsCache = $result;
        return $this->_arrayRowsCache;
    }

    protected function _construct()
    {
        $this->addColumn('selector_name', ['label' => __('Selector DOM Name'), 'renderer' => 'textarea']);
        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add New');
        parent::_construct();
    }
}
